=== debian/changelog ===
iddawc (1.1.9+ds-2build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:26:43 +0000

iddawc (1.1.9+ds-2) unstable; urgency=medium

  * d/patches/t64 fix conversion error in tests
  * d/control: Use pkgconf instead of pkg-config
  * d/copyright: Update copyright year to 2024 for debian/* files
  * d/control: Update idwcc package description

 -- Nicolas Mora <babelouest@debian.org>  Fri, 01 Mar 2024 07:52:58 -0500

iddawc (1.1.9+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062345

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 10:43:10 +0000

iddawc (1.1.9+ds-1) unstable; urgency=medium

  * New upstream release
  * d/watch: Repack to remove duplicate js files (Closes: #1048016)
  * d/rules: Add override_dh_auto_clean
  * d/control: Add node-qrcode-generator in build deps
  * d/libiddawc-dev.install: Add cmake dependencies
  * d/rules: Remove configure option -DDOWNLOAD_DEPENDENCIES=OFF
  * d/rules: Add configure option -DBUILD_IDWCC=ON
  * d/copyright: Add Files-Excluded and remove cmake-modules/DownloadProject/*
  * lintian-overrides: Update ignored warnings
  * d/patches: remove patches

 -- Nicolas Mora <babelouest@debian.org>  Sat, 18 Nov 2023 10:38:09 -0500
