=== debian/control ===
Source: iddawc
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Nicolas Mora <babelouest@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
             , liborcania-dev
             , libyder-dev
             , libulfius-dev
             , librhonabwy-dev
             , libgnutls28-dev
             , libjansson-dev
             , zlib1g-dev
             , cmake
             , pkgconf
             , check
             , doxygen
             , gnutls-bin
             , fonts-fork-awesome
             , libjs-jquery
             , libjs-bootstrap4
             , libjs-popper.js
             , node-qrcode-generator
Standards-Version: 4.6.2
Homepage: https://github.com/babelouest/iddawc
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/iddawc
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/iddawc.git
Rules-Requires-Root: no

Package: libiddawc1.1t64
Provides: ${t64:Provides}
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libiddawc1.1 (<< ${source:Version}), libiddawc0.9 (<< 0.9.8-2)
Replaces: libiddawc1.1, libiddawc0.9 (<< 0.9.8-2)
Description: OAuth2 and OIDC client library
 Handles the OAuth2 and OpenID Connect authentication process flow from the
 client side.
 .
  - Generates requests based on input parameters
  - Parses response
  - Validates response values

Package: libiddawc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libiddawc1.1t64 (= ${binary:Version}), ${misc:Depends}
       , liborcania-dev
       , libyder-dev
       , libulfius-dev
       , librhonabwy-dev
       , libgnutls28-dev
       , libjansson-dev
       , zlib1g-dev
Description: OAuth2 and OIDC client library - development
 Handles the OAuth2 and OpenID Connect authentication process flow from the
 client side.
 .
  - Generates requests based on input parameters
  - Parses response
  - Validates response values
 .
 This package contains the development files.

Package: idwcc
Architecture: any
Depends: ${shlibs:Depends}
       , ${misc:Depends}
       , libiddawc1.1t64 (= ${binary:Version})
       , fonts-fork-awesome
       , libjs-jquery
       , libjs-bootstrap4
       , libjs-popper.js
Description: Client for OAuth2/OIDC AS configuration validation
 Provides a web application to be used as an OpenID Connect or OAuth2
 client for local tests or validation.
 .
 Supports PKCE, token introspection, revocation, client registration,
 DPoP, Rich Authorization Request, Pushed Authorization Request,
 JWT Access tokens, encrypted tokens, requests and responses.
 .
 This web application is NOT intended to run in production mode,
 because all the client secrets, keys configuration and metadata are
 fully accessible to the user via the form or the javascript console.
 .
 By default, the application is available to localhost only, for security
 reason.
