=== debian/watch ===
version=4

# https://github.com/babelouest/iddawc
opts=\
repacksuffix=+ds,\
repack,compression=xz,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/iddawc-$1/ \
 https://github.com/babelouest/iddawc/tags .*/archive/.*/v?([\d\.]+).tar.gz
